import * as i0 from '@angular/core';
import { Component, Input, NgModule, EventEmitter, Output } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import { __classPrivateFieldGet, __classPrivateFieldSet } from 'tslib';
import { BehaviorSubject } from 'rxjs';
import { FormsModule } from '@angular/forms';

class CodeEditorComponent {
    constructor() {
        this.placeholder = 'need professionals help';
        this.contentWidth = 800;
        this.contentHeight = 600;
    }
}
CodeEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CodeEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: CodeEditorComponent, selector: "ngx-code-editor", inputs: { placeholder: "placeholder", contentWidth: "contentWidth", contentHeight: "contentHeight" }, ngImport: i0, template: "<div class=\"editor-wrapper\">\n  <div id=\"ngx-code-editor-container\" class=\"editor-wrapper-content\" [style.width.px]=\"contentWidth\" [style.height.px]=\"contentHeight\">\n    <!--        <div class=\"editor-wrapper-placeholder\">{{placeholder}}</div>-->\n  </div>\n</div>\n", styles: [".editor-wrapper{position:relative}.editor-wrapper-content{border:1px solid grey}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-code-editor', template: "<div class=\"editor-wrapper\">\n  <div id=\"ngx-code-editor-container\" class=\"editor-wrapper-content\" [style.width.px]=\"contentWidth\" [style.height.px]=\"contentHeight\">\n    <!--        <div class=\"editor-wrapper-placeholder\">{{placeholder}}</div>-->\n  </div>\n</div>\n", styles: [".editor-wrapper{position:relative}.editor-wrapper-content{border:1px solid grey}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { placeholder: [{
                type: Input
            }], contentWidth: [{
                type: Input
            }], contentHeight: [{
                type: Input
            }] } });

class CodeEditorModule {
}
CodeEditorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CodeEditorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, declarations: [CodeEditorComponent], imports: [CommonModule], exports: [CodeEditorComponent] });
CodeEditorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [CodeEditorComponent],
                    exports: [CodeEditorComponent]
                }]
        }] });

const regPrefix = /^([^/:]+):\/*/;
const urlJoin = (...paths) => {
    paths = paths.filter(d => d !== '');
    if (paths.length === 0) {
        return '';
    }
    const findIndex = paths.findIndex(d => !(typeof d !== 'string' || typeof d !== 'number'));
    if (findIndex >= 0) {
        throw new Error('paths must be a string or number');
    }
    let prefix = '';
    const firstPath = `${paths[0]}`;
    if (firstPath.startsWith('//')) {
        prefix = '//';
    }
    else if (firstPath.startsWith('/')) {
        prefix = '/';
    }
    else {
        if (firstPath.startsWith('file:') && paths.length > 1 && (firstPath + paths[1]).match(/^file:\/\/\//)) {
            prefix = firstPath.replace(regPrefix, '$1:///');
        }
        else {
            prefix = firstPath.replace(regPrefix, '$1://');
        }
        paths.shift();
    }
    if (prefix && !prefix.endsWith('/')) {
        prefix += '/';
    }
    let pathStr = paths
        .map(path => `${path}`
        .replace(/^\/+/, '')
        .replace(/^\.\/+/, '')
        .replace(/\/+$/, ''))
        .filter(d => d !== '')
        .join('/');
    while (pathStr.includes('/../')) {
        const pathArr = pathStr.split('/');
        const index = pathArr.findIndex(d => d === '..');
        pathArr.splice(index - 1, 2);
        pathStr = pathArr.join('/');
    }
    let backStr = prefix + pathStr;
    if (backStr.includes('?')) {
        const parts = backStr.split('?').filter(d => d !== '');
        backStr = parts.shift() + '?';
        if (parts.length > 0) {
            backStr += parts.join('&');
        }
    }
    return backStr.replace(/\/(\?|&|#[^!])/g, '$1');
};

var _LoadMonacoEditor_load;
// noinspection TypeScriptUnresolvedVariable
/**
 * moaco loader
 */
class LoadMonacoEditor {
    constructor(baseUrl, language, theme, defaultValue, localizeCode) {
        this.baseUrl = baseUrl;
        this.language = language;
        this.theme = theme;
        this.defaultValue = defaultValue;
        this.localizeCode = localizeCode;
        _LoadMonacoEditor_load.set(this, void 0);
        this.supportLanguages = ['de', 'es', 'fr', 'it', 'ja', 'ko', 'ru', 'zh-cn', 'zh-tw'];
    }
    /**
     * the language in current nation
     * @protected
     */
    currentLanguage() {
        try {
            const lang = navigator.language.toLocaleLowerCase();
            const findLang = this.supportLanguages.find(l => lang === l) || '';
            if (lang && !findLang) {
                console.error(`not support language ${lang}`);
            }
            return findLang;
        }
        catch (error) {
            console.error(error);
            return '';
        }
    }
    load() {
        if (!__classPrivateFieldGet(this, _LoadMonacoEditor_load, "f")) {
            __classPrivateFieldSet(this, _LoadMonacoEditor_load, new Promise(resolve => {
                const win = window;
                // if (typeof win.monaco === 'object') {
                //   resolve();
                //   return;
                // }
                const onGotAMDLoader = () => {
                    win.require.config({
                        paths: {
                            vs: 'monaco-editor/min/vs',
                            tokenizer: 'monaco-ace-tokenizer/dist'
                        },
                        'vs/nls': {
                            availableLanguages: {
                                '*': this.localizeCode || this.currentLanguage()
                            }
                        }
                    });
                    win.require(['vs/editor/editor.main', 'tokenizer/monaco-tokenizer', 'tokenizer/definitions/groovy'], (a, MonacoAceTokenizer, GroovyDefinition) => {
                        win.monaco.languages.register({
                            id: 'groovy'
                        });
                        MonacoAceTokenizer.registerRulesForLanguage('groovy', new GroovyDefinition.default());
                        // /* To load All languages */
                        // win.require(['vs/editor/editor.main', 'tokenizer/monaco-tokenizer'], (_: any, MonacoAceTokenizer: any) =>{
                        //   MonacoAceTokenizer.AVAILABLE_LANGUAGES.forEach((lang: string) => {
                        //     win.require(['tokenizer/definitions/' + lang], (LangDefinition: any) =>{
                        //       win.monaco.languages.register({
                        //         id: lang,
                        //       });
                        //       MonacoAceTokenizer.registerRulesForLanguage(lang, new LangDefinition.default);
                        //     });
                        //   });
                        // });
                        resolve();
                    });
                };
                if (!win.require) {
                    const loaderScript = document.createElement('script');
                    loaderScript.id = 'ngx-code-editor-load-monaco-script';
                    loaderScript.type = 'text/javascript';
                    loaderScript.src = urlJoin(this.baseUrl, 'monaco-editor/min/vs/loader.js');
                    loaderScript.addEventListener('load', onGotAMDLoader);
                    document.body.appendChild(loaderScript);
                }
                else {
                    onGotAMDLoader();
                }
            }), "f");
        }
        return __classPrivateFieldGet(this, _LoadMonacoEditor_load, "f");
    }
    /**
     * create the monaco-edtior by the dom
     */
    createMonacoEditor() {
        const win = window;
        win.ngxCodeEditor = win.monaco.editor.create(document.getElementById('ngx-code-editor-container'), {
            // todo: options from params
            value: this.defaultValue,
            automaticLayout: true,
            wordWrap: 'on',
            autoClosingBrackets: 'beforeWhitespace',
            autoClosingQuotes: 'beforeWhitespace',
            smoothScrolling: true,
            suggestFontSize: 16,
            language: this.language,
            theme: this.theme
        });
    }
}
_LoadMonacoEditor_load = new WeakMap();

const BASE_MONACO_URL = '';
/**
 * get default url
 * @param baseUrl default url
 */
const getBaseMonacoUrl = (baseUrl) => baseUrl || '' || BASE_MONACO_URL;

let loader;
class CodeEditorAppComponent {
    constructor() {
        /* default code language */
        this.language$ = new BehaviorSubject('');
        this._language = '';
        /* default theme */
        this.theme$ = new BehaviorSubject('');
        this._theme = 'vs';
        /* default code value */
        this.defaultValue$ = new BehaviorSubject('');
        this._defaultValue = '';
        /* width of conetnt area need a fixed value */
        this.contentWidth = 800;
        /* height of conetnt area need a fixed value */
        this.contentHeight = 600;
        // Event when the value of conetnt change
        this.contentChange = new EventEmitter();
        /* the label of switch language */
        this.languageLabel = 'CodeLanguages';
        /* the label of switch theme */
        this.themeLabel = 'Themes';
    }
    get language() {
        return this._language;
    }
    set language(language) {
        this.language$.next(language);
        this._language = language;
    }
    get theme() {
        return this._theme;
    }
    set theme(theme) {
        this.theme$.next(theme);
        this._theme = theme;
    }
    get defaultValue() {
        return this._defaultValue;
    }
    set defaultValue(defaultValue) {
        this.defaultValue$.next(defaultValue);
        this._defaultValue = defaultValue;
    }
    ngOnDestroy() {
        this.language$?.unsubscribe();
        this.theme$?.unsubscribe();
        this.defaultValue$?.unsubscribe();
    }
    async ngOnInit() {
        const win = window;
        const baseUrl = getBaseMonacoUrl(this.baseUrl);
        if (!loader) {
            loader = new LoadMonacoEditor(baseUrl, this.language, this.theme, this.defaultValue, this.localizeCode);
        }
        await loader.load();
        // call function to create code-editor every time
        loader.createMonacoEditor();
        // listen changes of the conetnt and emit the current value
        win.rgCodeEditor?.onDidChangeModelContent((res) => {
            this.contentChange.next(this.getValue());
        });
        this.language$.subscribe(language => {
            this.languageChange(language);
        });
        this.theme$.subscribe(theme => {
            this.themeChange(theme);
        });
        this.defaultValue$.subscribe(defaultValue => {
            this.setValue(defaultValue);
        });
    }
    /**
     * switch theme
     */
    themeChange(theme) {
        const win = window;
        win.monaco?.editor?.setTheme(theme || this.theme);
    }
    /**
     * switch code language
     */
    languageChange(language) {
        const win = window;
        win.monaco?.editor?.setModelLanguage(win.ngxCodeEditor?.getModel(), language || this.language);
    }
    /**
     * get current code value
     */
    getValue() {
        const win = window;
        const value = win.ngxCodeEditor?.getValue();
        return value;
    }
    /**
     * set the value of content
     */
    setValue(value) {
        const win = window;
        win.ngxCodeEditor?.setValue(value || this.defaultValue);
    }
}
CodeEditorAppComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CodeEditorAppComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.2.2", type: CodeEditorAppComponent, selector: "ngx-code-editor-app", inputs: { baseUrl: "baseUrl", localizeCode: "localizeCode", language: "language", theme: "theme", defaultValue: "defaultValue", contentWidth: "contentWidth", contentHeight: "contentHeight", languageLabel: "languageLabel", themeLabel: "themeLabel", selection: "selection" }, outputs: { contentChange: "contentChange" }, ngImport: i0, template: "\n<ng-container *ngIf=\"selection\">\n  <ng-container *ngTemplateOutlet=\"selection; let data\"></ng-container>\n</ng-container>\n<ngx-code-editor [contentWidth]=\"contentWidth\" [contentHeight]=\"contentHeight\"></ngx-code-editor>\n", styles: [".section-row,.section-row-item{display:flex;flex-direction:row;align-items:center}\n"], components: [{ type: CodeEditorComponent, selector: "ngx-code-editor", inputs: ["placeholder", "contentWidth", "contentHeight"] }], directives: [{ type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-code-editor-app', template: "\n<ng-container *ngIf=\"selection\">\n  <ng-container *ngTemplateOutlet=\"selection; let data\"></ng-container>\n</ng-container>\n<ngx-code-editor [contentWidth]=\"contentWidth\" [contentHeight]=\"contentHeight\"></ngx-code-editor>\n", styles: [".section-row,.section-row-item{display:flex;flex-direction:row;align-items:center}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { baseUrl: [{
                type: Input
            }], localizeCode: [{
                type: Input
            }], language: [{
                type: Input
            }], theme: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], contentWidth: [{
                type: Input
            }], contentHeight: [{
                type: Input
            }], contentChange: [{
                type: Output
            }], languageLabel: [{
                type: Input
            }], themeLabel: [{
                type: Input
            }], selection: [{
                type: Input
            }] } });

class CodeEditorAppModule {
}
CodeEditorAppModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CodeEditorAppModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, declarations: [CodeEditorAppComponent], imports: [CommonModule, FormsModule, CodeEditorModule], exports: [CodeEditorAppComponent] });
CodeEditorAppModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, imports: [[CommonModule, FormsModule, CodeEditorModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: CodeEditorAppModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CodeEditorAppComponent],
                    imports: [CommonModule, FormsModule, CodeEditorModule],
                    exports: [CodeEditorAppComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { CodeEditorAppComponent, CodeEditorAppModule, CodeEditorComponent, CodeEditorModule, LoadMonacoEditor, getBaseMonacoUrl, urlJoin };
//# sourceMappingURL=ngx-code-editor.mjs.map
