import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { BehaviorSubject } from "rxjs";
import * as i0 from "@angular/core";
export declare class CodeEditorAppComponent implements OnInit, OnDestroy {
    baseUrl?: string;
    /**
     * According to current browser to get current language
     * @example  'de' | 'es' | 'fr' | 'it' | 'ja' | 'ko' | 'ru' | 'zh-cn' | 'zh-tw'
     */
    localizeCode?: string;
    language$: BehaviorSubject<string>;
    private _language;
    get language(): string;
    set language(language: string);
    theme$: BehaviorSubject<string>;
    private _theme;
    get theme(): string;
    set theme(theme: string);
    defaultValue$: BehaviorSubject<string>;
    private _defaultValue;
    get defaultValue(): string;
    set defaultValue(defaultValue: string);
    contentWidth: number;
    contentHeight: number;
    contentChange: EventEmitter<string>;
    languageLabel: string;
    themeLabel: string;
    selection?: TemplateRef<any>;
    constructor();
    ngOnDestroy(): void;
    ngOnInit(): Promise<void>;
    /**
     * switch theme
     */
    themeChange(theme: string): void;
    /**
     * switch code language
     */
    languageChange(language: string): void;
    /**
     * get current code value
     */
    getValue(): string;
    /**
     * set the value of content
     */
    setValue(value?: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CodeEditorAppComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CodeEditorAppComponent, "ngx-code-editor-app", never, { "baseUrl": "baseUrl"; "localizeCode": "localizeCode"; "language": "language"; "theme": "theme"; "defaultValue": "defaultValue"; "contentWidth": "contentWidth"; "contentHeight": "contentHeight"; "languageLabel": "languageLabel"; "themeLabel": "themeLabel"; "selection": "selection"; }, { "contentChange": "contentChange"; }, never, never>;
}
